#include <bits/stdc++.h>
using namespace std;
using LL=long long;
#define FOR(i, l, r)for(int i = (l); i<=(r);++i)
#define REP(i, n)FOR(i,0,(n)-1)
#define ssize(x)int(x.size())
#define debug(X...)cerr<<"["#X"]: ", [](auto...$){((cerr<<$<<"; "),...)<<endl;}(X)

auto&operator<<(auto&o,pair<auto, auto>p) {
    return o << "(" << p.first << ", " << p.second << ")";
}
auto operator<<(auto&o, auto x)->decltype(x.end(),o){
    o<<"{";int i=0;for(auto e:x)o<<", "+!i++<<e;return o<<"}";}

int main() {
    int N; cin >> N;

    vector<pair<char, char>> v(N);

    for(int i = 0; i < N; i++) {
        char c; cin >> c;
        v[i].second = c;
    }

    for(int i = 0; i < N; i++) {
        char c; cin >> c;
        v[i].first = c;
    }

    vector <pair <char, int> > chcePusty, CdoM, MdoC, chceM, chceC;

    for(int i = 0; i < N; i++) {
        if(v[i].second == '-') chcePusty.push_back({v[i].first, i});
        if(v[i].first == 'M' && v[i].second == 'C') CdoM.push_back({v[i].first, i});
        if(v[i].first == 'C' && v[i].second == 'M') MdoC.push_back({v[i].first, i});
        if(v[i].first != 'C' && v[i].second == 'C') chceC.push_back({v[i].first, i});
        if(v[i].first != 'M' && v[i].second == 'M') chceM.push_back({v[i].first, i});
    }

    sort(chcePusty.begin(), chcePusty.end());

    int chcePustyI = 0, CdoMI = 0, MdoCI = 0, chceMI = 0, chceCI = 0;
    queue <string> odp;

    int current = -1;
    char motor = '-';

    // pick start position
    current = chcePusty[chcePustyI].second;
    motor = chcePusty[chcePustyI].first;

    debug(chcePusty);

    while (chcePustyI != chcePusty.size()) {
        if (motor != '-') {
            if (motor == 'M') {
                odp.push("DRIVE " + to_string(current) + '\n');
                odp.push("DROPOFF\n");

                if (chceMI != chceM.size()) {
                    current = chceM[chceMI].second;
                    motor = chceM[chceMI].first;
                    chceMI += 1;
                    odp.push("PICKUP " + to_string(current) + '\n');
                } else {
                    odp.push("DROPOFF\n");
                    motor = '-';
                }
            } else {
                odp.push("DRIVE " + to_string(current) + '\n');
                odp.push("DROPOFF\n");

                if (chceCI != chceC.size()) {
                    current = chceC[chceCI].second;
                    motor = chceC[chceCI].first;
                    chceCI += 1;
                    odp.push("PICKUP " + to_string(current) + '\n');
                } else {
                    odp.push("DROPOFF\n");
                    motor = '-';
                }
            }
        } else {
            chcePustyI += 1;
            current = chcePusty[chcePustyI].second;
            motor = chcePusty[chcePustyI].first;
            odp.push("DRIVE " + to_string(current) + '\n');
        }
    }

    cout << odp.size() << endl;
    while(!odp.empty()) {
        cout << odp.front();
        odp.pop();
    }
}
